#include <stdio.h>
#include <string.h>
#include <time.h>
#include <ctype.h>

extern "C"
{
#include <cgi-lib.h>
#include <html-lib.h>
}

#define TextSize 512	//a practical limit for input text size
#define VERSIONDATE "April 21, 2000"
#define MAXCODESIZE 65536
#define MAXLISTNODES 512

//--------------------------------------------------------------------
class listnode
{
public:
	listnode(char v);
	void setkeycode(int code); /* saves code of keyword */
	char val;		//character value
	int keyword;	//keyword code(nextchar should be 0)
	int state;		//state number
	int passes;	    //how many keywords passed this state
	int reserved;   //reserved state
	listnode *nextchar;	//next char in a string
	listnode *altchar;	//alternative char
protected:
};
//--------------------------------------------------------------------
class listtree
{
public:
	listtree(bool insens, bool whole);
	~listtree();
	int totalstates()
	{
		return nextstate - 1;
	}
	char *addkeyword(char *t); /* add a keyword to the tree */
	int jumptable(char *code);
	int statetable(char *code);
	listnode *searchstate(int state);
	listnode *searchnextstate(listnode *to);
	listnode *searchnextstate2(int tostate);

	int keywords;
	int Error;
protected:
	bool insensitive;
	bool wholeword;
	int searchindex;
	int searchnextindex;
	listnode *Start;	//root node
	listnode *List[MAXLISTNODES]; //linear list of all nodes
	int ListIndex;
	int nextstate;
};
//--------------------------------------------------------------------
class LinkedStrings
{
public:
	LinkedStrings();
	LinkedStrings *LinkedStrings :: addString(
		LinkedStrings **List,
		char *newstr);
	char str[20];
	LinkedStrings *next;
};

class TextFormEntry
{
public:
	TextFormEntry();
	~TextFormEntry();
	void ParseCharsList();
	void printList();
	void printfCode();
	char textBuf[256];
	char text[256];
	LinkedStrings *CharsList;	//parsed list of chars ('x', 's', 0x0d, 13, 12..)


};
//--------------------------------------------------------------------

void
ReportError(char Err);

int
generate(char *Text, bool Insense, bool Whole);

void
TimeStamp();

void
Banner();
